TraitTypeCheckingExtension (Groovy 5.1.0)
Description: declaration: package: org.codehaus.groovy.transform.stc, class: TraitTypeCheckingExtension

Package org.codehaus.groovy.transform.stc

# Class TraitTypeCheckingExtension

java.lang.Object
org.codehaus.groovy.transform.stc.TypeCheckingExtension
org.codehaus.groovy.transform.stc.AbstractTypeCheckingExtension
org.codehaus.groovy.transform.stc.TraitTypeCheckingExtension

public class TraitTypeCheckingExtension extends AbstractTypeCheckingExtension
An extension that handles field, super and static method calls within a trait.

Since:
  2.3.0

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.codehaus.groovy.transform.stc.AbstractTypeCheckingExtension

  `AbstractTypeCheckingExtension.TypeCheckingScope`

- ## Field Summary

  ### Fields inherited from class org.codehaus.groovy.transform.stc.AbstractTypeCheckingExtension

  `context, debug, handled`

  ### Fields inherited from class org.codehaus.groovy.transform.stc.TypeCheckingExtension

  `typeCheckingVisitor`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TraitTypeCheckingExtension(StaticTypeCheckingVisitor typeCheckingVisitor)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<MethodNode>`
  `handleMissingMethod(ClassNode receiver, String name, ArgumentListExpression argumentList, ClassNode[] argumentTypes, MethodCall call)`
  This method is called by the type checker when a method call cannot be resolved.
  `boolean`
  `handleUnresolvedProperty(PropertyExpression pexp)`
  This method is called by the type checker when a property expression cannot be resolved (for example, when a property doesn't exist).

  ### Methods inherited from class org.codehaus.groovy.transform.stc.AbstractTypeCheckingExtension

  `argTypeMatches, argTypeMatches, argTypesMatches, argTypesMatches, delegatesTo, delegatesTo, delegatesTo, firstArgTypesMatches, firstArgTypesMatches, getArguments, getCurrentScope, getEnclosingBinaryExpression, getEnclosingBinaryExpressionStack, getEnclosingClassNode, getEnclosingClassNodes, getEnclosingClosure, getEnclosingClosureStack, getEnclosingMethod, getEnclosingMethodCall, getEnclosingMethodCalls, getEnclosingMethods, getGeneratedMethods, isAnnotatedBy, isAnnotatedBy, isDynamic, isExtensionMethod, isGenerated, isMethodCall, log, makeDynamic, makeDynamic, makeDynamic, makeDynamic, makeDynamic, makeDynamic, newMethod, newMethod, newMethod, newScope, newScope, popEnclosingBinaryExpression, popEnclosingClassNode, popEnclosingClosure, popEnclosingMethod, popEnclosingMethodCall, popTemporaryTypeInfo, pushEnclosingBinaryExpression, pushEnclosingClassNode, pushEnclosingClosureExpression, pushEnclosingMethod, pushEnclosingMethodCall, pushTemporaryTypeInfo, safeCall, scopeExit, scopeExit, setHandled, unique, withTypeChecker`

  ### Methods inherited from class org.codehaus.groovy.transform.stc.TypeCheckingExtension

  `addStaticTypeError, afterMethodCall, afterVisitClass, afterVisitMethod, beforeMethodCall, beforeVisitClass, beforeVisitMethod, buildListType, buildMapType, classNodeFor, classNodeFor, existsProperty, existsProperty, extractStaticReceiver, finish, getArgumentTypes, getTargetMethod, getType, handleAmbiguousMethods, handleIncompatibleAssignment, handleIncompatibleReturnType, handleUnresolvedAttribute, handleUnresolvedVariableExpression, isStaticMethodCallOnClass, lookupClassNodeFor, onMethodSelection, parameterizedType, setup, storeType`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### TraitTypeCheckingExtension

    public TraitTypeCheckingExtension(StaticTypeCheckingVisitor typeCheckingVisitor)

- ## Method Details

  - ### handleMissingMethod

    public List<MethodNode> handleMissingMethod(ClassNode receiver, String name, ArgumentListExpression argumentList, ClassNode[] argumentTypes, MethodCall call)
    Description copied from class: `TypeCheckingExtension`
    This method is called by the type checker when a method call cannot be resolved. Extensions may override this method to handle missing methods and prevent the type checker from throwing an error.
    Overrides:
      `handleMissingMethod` in class `TypeCheckingExtension`
    Parameters:
      `receiver` - the type of the receiver
      `name` - the name of the called method
      `argumentList` - the list of arguments of the call
      `argumentTypes` - the types of the arguments of the call
      `call` - the method call itself, if needed
    Returns:
      an empty list if the extension cannot resolve the method, or a list of potential methods if the extension finds candidates. This method must not return null.

  - ### handleUnresolvedProperty

    public boolean handleUnresolvedProperty(PropertyExpression pexp)
    Description copied from class: `TypeCheckingExtension`
    This method is called by the type checker when a property expression cannot be resolved (for example, when a property doesn't exist). It gives the extension a chance to resolve it.
    Overrides:
      `handleUnresolvedProperty` in class `TypeCheckingExtension`
    Parameters:
      `pexp` - the unresolved property
    Returns:
      `boolean` false if this extension doesn't resolve the property, true if it resolves the property.